\documentclass[12pt, a4paper]{article}
\usepackage[top=1cm,bottom=2cm,left=2.5cm,right=2.5cm]{geometry}
\usepackage[utf8]{inputenc}
\usepackage[english]{babel}
\usepackage{amsmath}
\usepackage{amsfonts}
\usepackage{amssymb}
\usepackage{amsthm}
\usepackage{mathtools}
\usepackage[osf]{mathpazo}
\usepackage{eulervm}
\usepackage{MnSymbol}
\usepackage{array}
\usepackage{enumitem}
\usepackage{booktabs}
\usepackage{multirow}
\usepackage[linesnumbered, ruled, vlined]{algorithm2e}
\usepackage{graphicx}
\usepackage{float}
\usepackage{tikz}
\usepackage{tikz-3dplot}
\usepackage{listings}
\usepackage{enumitem}
\usepackage{wrapfig}
\usepackage{bbm}
\newcommand*\red[1]{{\color{red}#1}}
\newcommand*\circled[1]{\tikz[baseline=(char.base)]{
            \node[shape=circle,draw,inner sep=2pt] (char) {#1};}}
\usepackage[justification=centering]{caption}
\usetikzlibrary{calc, arrows, automata, graphs, shapes, petri, decorations.pathmorphing}
\parindent = 0pt
\frenchspacing
\let\emptyset\varnothing
\let\epsilon\varepsilon
\let\rho\varrho
\let\theta\vartheta

% define environments
\theoremstyle{definition}
\newtheorem{definition}{Definition}
\newtheorem*{remark*}{Remark}
\newtheorem*{example*}{Example}

\theoremstyle{plain}
\newtheorem{lemma}[definition]{Lemma}
\newtheorem{theorem}[definition]{Theorem}

\renewcommand{\labelenumi}{(\roman{enumi})}
\renewcommand{\labelenumi}{(\roman{enumi})}

\author{Niklas Rieken}
\title{Linear Programs}

\begin{document}
\maketitle

A \emph{linear program} (\emph{LP}) consists of \emph{variables} $x = (x_1, \ldots, x_n)$, an \emph{objective function} $z(x) = c^Tx$ with $c \in \mathbb{Q}^n$ that can either be maximized or minimized, and \emph{constraints} $a^T x \sim b$ with $a \in \mathbb{Q}^n, b \in \mathbb{Q}, \sim \in \{\leq, =, \geq\}$. An LP is in \emph{canonical form} if it is written as
\begin{align*}
	\text{maximize }	& c_1 x_1 + c_2 x_2 + \ldots + c_n x_n\\
	\text{subject to }	& a_{11} x_1 + a_{12} x_2 + \ldots + a_{1n} x_n	&&\leq b_1\\
						& a_{21} x_1 + a_{22} x_2 + \ldots + a_{2n} x_n &&\leq b_2\\
						& \quad\quad\quad\quad\quad\vdots & \\
						& a_{m1} x_1 + a_{m2} x_2 + \ldots + a_{mn} x_n &&\leq b_m\\
						& x_1, x_2,	\ldots, x_n							&&\geq 0
\end{align*}
or shorter
\begin{align*}
	\text{maximize }	& \sum_{j=1}^n c_j x_j\\
	\text{subject to }	& \sum_{j=1}^n a_{ij} x_j \leq b_i	& i \in \{1, \ldots, m\}\\
						& x_j \geq 0						& j \in \{1, \ldots, n\}
\end{align*}	
or even shorter
\begin{align*}
	\text{maximize }	& c^T x\\
	\text{subject to }	& Ax \leq b\\
						& x \geq 0.
\end{align*}
We call the $x_j$ ($j \in \{1, \ldots, n\}$) \emph{decision variables}, $c^T$ the \emph{objective function coefficients}, $A$ the \emph{coefficient matrix}, and $b$ the \emph{right hand side} of the LP. Moreover, we write $a_i^T$ for the coefficients of the $i$-th constraint. Note that every LP has an ''equivalent`` LP in canonical form:
\begin{itemize}
	\item $\min_x c^T x = \max_x -c^T x$,
	\item $a_i^T x \geq b_i$ iff $-a_i^T x \leq -b_i$,
	\item $a_i^T x = b_i$ iff $a_i^T x \leq b_i$ and $a_i^T x \geq b_i$,
	\item $x_j \leq 0$ iff $-x_j \geq 0$,
	\item $x_j$ unbounded: Replace $x_j = x_j^+ - x_j^-$ with $x_j^+, x_j^- \geq 0$. 
\end{itemize}

Every constraint (from an LP in canonical form) defines a \emph{halfspace} in $\mathbb{R}^n$ and its separating hyperplane has $a_i^T$ as its normal vector.
\begin{figure}[H]
	\centering
	\begin{tikzpicture}
		\draw[-] (0, 0) -- (3, -2) coordinate(p1) coordinate[pos=.75] (a);
		\draw[->,red,thick] (a) -- ($(a)!.5cm!90:(p1)$) node[pos=1.4]{\scriptsize$a_i^T$};
		\draw[white,fill=gray!20] (0, 0) -- (-.5, 0) -- (-.5, -2.5) -- (3, -2.5) -- (3, -2);

		\node (feas) at (.7, -1.7) {\scriptsize{''feasible``}};
		\node (infeas) at (2.3, -.3) {\scriptsize{''infeasible``}};
	\end{tikzpicture}
\end{figure}

We call the set of points that satisfy all constraints \emph{feasible region} $P \coloneq \{x \in \mathbb{R}^n \mid Ax \leq b, x \geq 0\}$. $P$ is a \emph{polyhedron}, i.e. the intersection of finitely many halfspaces. If $P$ is bounded, it is called a \emph{polytope}.
\begin{figure}[H]
	\centering
	\begin{tikzpicture}
		\begin{scope}
			\path[fill=gray!20] (0, 0) coordinate(p1) -- ++(35:2.5) coordinate(p2) -- ++(-45:2.5) coordinate(p3) -- ++(-120:3.5) coordinate(p4) -- ++(150:3) coordinate(p5);
			\node at (barycentric cs:p1=1,p2=1,p3=1,p4=1,p5=1) {$P$};
			\foreach \X [count=\Y] in {2,...,6} {
				\ifnum\X=6
					\path (p\Y) -- (p1) coordinate[pos=-0.2](a\Y) coordinate[pos=1.2](a1) coordinate[pos=0.5](m1);
					\draw (a\Y) -- (a1);
					\draw[->,red,thick] (m1) -- ($(m1)!1.2cm!90:(p1)$) node[pos=1.2]{$a_{\Y}^T$};
				\else
					\path (p\Y) -- (p\X) coordinate[pos=-0.2](a\Y) coordinate[pos=1.2](a\X) coordinate[pos=0.5](m\X);
					\draw (a\Y) -- (a\X);
					\draw[->,red,thick] (m\X) -- ($(m\X)!1.2cm!90:(p\X)$) node[pos=1.25]{$a_{\Y}^T$};
				\fi
			}
			\node (bounded) at (1.5, -5) {\scriptsize{''bounded``}};
		\end{scope}
		\begin{scope}[shift={(6, 1)}]
			\path[fill=gray!20] (1, -1) coordinate(q1) -- (3, -4) coordinate(q2) -- (5, -4) coordinate(q3) -- (6, -1) coordinate(q4);
			\node at (barycentric cs:q1=1,q2=1,q3=1,q4=1) {$P$};
			\foreach \X [count=\Y] in {2, 3, 4} {
				\path (q\Y) -- (q\X) coordinate[pos=-.2](b\Y) coordinate[pos=1.2](b\X) coordinate[pos=.5](n\X);
				\draw (b\Y) -- (b\X);
				\draw[->,red,thick] (n\X) -- ($(n\X)!1.2cm!-90:(q\X)$) node[pos=1.25]{$a_{\Y}^T$};
			}
			\node (unbounded) at (4, -6) {\scriptsize{''unbounded``}};
		\end{scope}
	\end{tikzpicture}
\end{figure}

If the constraints contradict themselves (for instance, $x + y \leq 1$, $x \geq 2$, and $x, y \geq 0$), then $P = \emptyset$, a corresponsing LP is called \emph{infeasible}. Constraints might also be \emph{redundant}, i.e. a constraint can be omitted without increasing the polyhedron (for example, $x + y \geq 0$ and $x, y \geq 0$).
\begin{figure}[H]
	\centering
	\begin{tikzpicture}
		\begin{scope}
			\path (0, 0) coordinate(p1) -- (-3, -2) coordinate(p2) -- (1, -3) coordinate(p3);
			\path (p1) -- (p2) coordinate[pos=-.2](a1) coordinate[pos=1.2](a2) coordinate[pos=.3](m2);
			\draw (a1) -- (a2);
			\draw[->,red,thick] (m2) -- ($(m2)!.8cm!90:(p2)$);
			\path (p2) -- (p3) coordinate[pos=-.2](a2) coordinate[pos=1.2](a3) coordinate[pos=.5](m3);
			\draw (a2) -- (a3);
			\draw[->,red,thick] (m3) -- ($(m3)!.8cm!90:(p3)$);
			\path (p3) -- (p1) coordinate[pos=-.2](a3) coordinate[pos=1.2](a1) coordinate[pos=.4](m1);
			\draw (a3) -- (a1);
			\draw[->,red,thick] (m1) -- ($(m1)!.8cm!90:(p1)$);
			\node (infeasible) at (-.5, -3.5) {\scriptsize{''infeasible``}};
		\end{scope}
		\begin{scope}[shift={(4.5, 0)}]
			\path[fill=gray!20] (4, 1) coordinate(q1) -- (0, 0) coordinate(q2) -- (0, -2) coordinate(q3) -- (4, -3) coordinate(q4);
			\node at (barycentric cs:q1=1,q2=1,q3=1,q4=1) {$P$};
			\foreach \X [count=\Y] in {2, 3, 4} {
				\path (q\Y) -- (q\X) coordinate[pos=-.3](b\Y) coordinate[pos=1.3](b\X) coordinate[pos=.5](n\X);
				\draw (b\Y) -- (b\X);
				\draw[->,red,thick] (n\X) -- ($(n\X)!.8cm!-90:(q\X)$);
			}
			\draw (-.5, .5) -- (-.5, -2.5);
			\draw[->,red,thick] (-.5, -1.2) -- (-1.2, -1.2);
			\node (redundant) at (1.5, -3.5) {\scriptsize{''redundant``}};
		\end{scope}
	\end{tikzpicture}
\end{figure}

Polyhedra are \emph{convex}, i.e. they satisfy Jensen's inequality: For all $x, y \in P$ and all $\theta \in [0, 1]$, $(1-\theta)x + \theta y \in P$.
\begin{proof}
	Let $x, y \in P$ and $\theta \in [0, 1]$, then 
	$$
		(\underbrace{1-\theta}_{\geq 0})\underbrace{x}_{\geq 0} + \underbrace{\theta}_{\geq 0} \underbrace{y}_{\geq 0} \geq 0
	$$
	and moreover,
	\begin{align*}
		A((1-\theta)x + \theta y) &= (1-\theta)\underbrace{Ax}_{\leq b} + \theta \underbrace{Ay}_{\leq b}\\
		&\leq (1-\theta)b + \theta b\\
		&= b.\qedhere
	\end{align*}
\end{proof}

The \emph{dimension} $\dim P$ is the dimension of the smallest affine subspace containg $P$. If $P \subseteq \mathbb{R}^n$ with $\dim P = n$, then $P$ is called \emph{full dimensional}. 
For a given $x \in P$, a constraint $a_i^T x \leq b_i$ is called \emph{active} (or \emph{binding}) if $a_i^T x = b_i$.
A \emph{face} with respect to $H \subseteq \{1, \ldots, m\}$ is
$$
	F \coloneq \{x \in P \mid a_i^T x \leq b_i \text{ active in } x, i \in H\}.
$$
\begin{figure}[H]
	\centering
	\begin{tikzpicture}
		\begin{scope}
			\path[fill=gray!20] (0, 0) coordinate(p1) -- ++(35:2.5) coordinate(p2) -- ++(-45:2.5) coordinate(p3) -- ++(-120:3.5) coordinate(p4) -- ++(150:3) coordinate(p5);
			\node at (barycentric cs:p1=1,p2=1,p3=1,p4=1,p5=1) {$P$};
			\foreach \X [count=\Y] in {2,...,6} {
				\ifnum\X=6
					\path (p\Y) -- (p1) coordinate[pos=-0.2](a\Y) coordinate[pos=1.2](a1) coordinate[pos=0.5](m1);
					\draw[red] (a\Y) -- (a1);
				\else
					\ifnum\X=5
						\path (p\Y) -- (p\X) coordinate[pos=-0.2](a\Y) coordinate[pos=1.2](a\X) coordinate[pos=0.5](m\X);
						\draw[red] (a\Y) -- (a\X);
						\node[red] at (p5) {$\bullet$};
					\else
						\path (p\Y) -- (p\X) coordinate[pos=-0.2](a\Y) coordinate[pos=1.2](a\X) coordinate[pos=0.5](m\X);
						\draw (a\Y) -- (a\X);
					\fi
				\fi
			}
			\node (vertex) at (1.5, -4.5) {\scriptsize{''vertex ($0$-dim)``}};
		\end{scope}
		\begin{scope}[shift={(5.5, 0)}]
			\path[fill=gray!20] (0, -1) coordinate(p1) -- (2, -3) coordinate(p2) -- (3, -1) coordinate(p3) -- (2, 1) coordinate(p4) -- (0, 1) coordinate(p5);
			\node at (barycentric cs:p1=1,p2=1,p3=1,p4=1,p5=1) {$P$};
			\foreach \X [count=\Y] in {2,...,6} {
				\ifnum\X=6
					\path (p\Y) -- (p1) coordinate[pos=-0.2](a\Y) coordinate[pos=1.2](a1) coordinate[pos=0.5](m1);
					\draw (a\Y) -- (a1);
				\else
					\ifnum\X=3
						\path (p\Y) -- (p\X) coordinate[pos=-0.2](a\Y) coordinate[pos=1.2](a\X) coordinate[pos=0.5](m\X);
						\draw[red,very thick] (a\Y) -- (a\X);
					\else
						\path (p\Y) -- (p\X) coordinate[pos=-0.2](a\Y) coordinate[pos=1.2](a\X) coordinate[pos=0.5](m\X);
						\draw (a\Y) -- (a\X);
					\fi
				\fi
			}
			\node (edge) at (1.5, -4.5) {\scriptsize{''edge ($1$-dim)``}};
		\end{scope}
		\begin{scope}[shift={(10, -1)},scale=4.3]
			\coordinate (A1) at (0,0);
			\coordinate (A2) at (0.6,0.2);
			\coordinate (A3) at (1,0);
			\coordinate (A4) at (0.4,-0.2);
			\coordinate (B1) at (0.5,0.5);
			\coordinate (B2) at (0.5,-0.5);
			\draw[fill=gray!20] (A1) -- (A4) -- (B1);
			\draw[fill=gray!20] (A1) -- (A4) -- (B2);
			\draw[fill=gray!20] (A4) -- (A3) -- (B2);
			\draw[fill=red!60] (A4) -- (A3) -- (B1);
			\draw[dashed] (A1) -- (A2) -- (A3);
			\draw[dashed] (B1) -- (A2) -- (B2);
			\draw (A4) -- (A1) -- (B1);
			\draw (A4) -- (B2);
			\draw (A3) -- (A4) -- (B1);
			\draw (B1) -- (A1) -- (B2) -- (A3) ;
			\draw[red,thick](A4) -- (A3) -- (B1) -- cycle;
			\node at (.3, -.05) {$P$};
		\end{scope}
			\node (facet) at (12, -4.5) {\scriptsize{''facet ($(n-1)$-dim)``}};
	\end{tikzpicture}
\end{figure}

Every face itself is again a polyhedron. A point $x \in P$ is called \emph{feasible solution}, $x^\ast \in P$ such that $c^T x^\ast \geq c^T x$ for all $x \in P$ is called \emph{optimal solution} (provided that the objective function should be maximized), $c^T x^\ast$ is called \emph{optimum}.

\begin{theorem}[Fundamental Theorem of Linear Programming]
	For every LP exactly one of the following hold:
	\begin{enumerate}
		\item The LP is infeasible, i.e. $P = \emptyset$.
		\item The optimum is unbounded, i.e. for all $M > 0$, there exists $x \in P$ with $c^T x \geq M$.
		\item There exists a finite optimal solution.
	\end{enumerate}
	If the last case is true, then the optimal sollution is assumed at a vertex of $P$.
\end{theorem}
\begin{figure}[H]
	\centering
	\begin{tikzpicture}
		\begin{scope}[scale=.7]
			\path (0, 0) coordinate(p1) -- (-3, -2) coordinate(p2) -- (1, -3) coordinate(p3);
			\path (p1) -- (p2) coordinate[pos=-.2](a1) coordinate[pos=1.2](a2) coordinate[pos=.3](m2);
			\draw (a1) -- (a2);
			\path (p2) -- (p3) coordinate[pos=-.2](a2) coordinate[pos=1.2](a3) coordinate[pos=.5](m3);
			\draw (a2) -- (a3);
			\path (p3) -- (p1) coordinate[pos=-.2](a3) coordinate[pos=1.2](a1) coordinate[pos=.4](m1);
			\draw (a3) -- (a1);
			\path[draw,red] (-3, 0) coordinate(c1) -- (-2, -.5) coordinate(c2) coordinate[pos=.5](cm);
			\draw[red] (c1) -- (c2) node[pos=1.2] {$c$};
			\draw[red,thick,->] (cm) -- ($(cm)!.8cm!-90:(c2)$);
		\end{scope}
		\begin{scope}[shift={(2, 1)},scale=.7]
			\path[fill=gray!20] (1, -1) coordinate(q1) -- (3, -4) coordinate(q2) -- (5, -4) coordinate(q3) -- (6, -1) coordinate(q4);
			\node at (barycentric cs:q1=1,q2=1,q3=1,q4=1) {$P$};
			\foreach \X [count=\Y] in {2, 3, 4} {
				\path (q\Y) -- (q\X) coordinate[pos=-.2](b\Y) coordinate[pos=1.2](b\X) coordinate[pos=.5](n\X);
				\draw (b\Y) -- (b\X);
			}
			\path[draw,red] (2, 0) coordinate(c1) -- (3.5, -.3) coordinate(c2) coordinate[pos=.5](cm);
			\draw[red] (c1) -- (c2) node[pos=1.2] {$c$};
			\draw[red,thick,->] (cm) -- ($(cm)!.8cm!90:(c2)$);
		\end{scope}
		\begin{scope}[shift={(9, 0)},scale=.7]
			\path[fill=gray!20] (0, 0) coordinate(p1) -- ++(35:2.5) coordinate(p2) -- ++(-45:2.5) coordinate(p3) -- ++(-120:3.5) coordinate(p4) -- ++(150:3) coordinate(p5);
			\node at (barycentric cs:p1=1,p2=1,p3=1,p4=1,p5=1) {$P$};
			\foreach \X [count=\Y] in {2,...,6} {
				\ifnum\X=6
					\path (p\Y) -- (p1) coordinate[pos=-0.2](a\Y) coordinate[pos=1.2](a1) coordinate[pos=0.5](m1);
					\draw (a\Y) -- (a1);
				\else
					\path (p\Y) -- (p\X) coordinate[pos=-0.2](a\Y) coordinate[pos=1.2](a\X) coordinate[pos=0.5](m\X);
					\draw (a\Y) -- (a\X);
				\fi
			}
			\node at (p1) {\color{red}$\bullet$};
			\path[draw,red] (-1, .5) coordinate(c1) -- (0, 1.5) coordinate(c2) coordinate[pos=.5](cm);
			\draw[red] (c1) -- (c2) node[pos=1.2] {$c$};
			\draw[red,thick,->] (cm) -- ($(cm)!.8cm!90:(c2)$);
		\end{scope}
	\end{tikzpicture}
\end{figure}

\begin{lemma}
	An $n$-dimensional polyhedron given by $m$ constraints has at most $\binom{m}{n}$ vertices, i.e. finitely many.
\end{lemma}
Thus, of all (usually infinitely many) feasible points, only finitely many are relevant. However, enumerating all those points and choosing the best solution (\emph{brute force}) is still very inefficient.

Idea for the Simplex algorithm: Move from vertex to vertex such that the objective value only increases (decreases, respectively, if objective is to minimize).
\begin{figure}[H]
	\centering
	\begin{tikzpicture}
		\path[fill=gray!20] (0, 0) coordinate(p1) -- ++(35:2.5) coordinate(p2) -- ++(-45:2.5) coordinate(p3) -- ++(-120:3.5) coordinate(p4) -- ++(150:3) coordinate(p5);
		\node at (barycentric cs:p1=1,p2=1,p3=1,p4=1,p5=1) {$P$};
		\foreach \X [count=\Y] in {2,...,6} {
			\ifnum\X=6
				\path (p\Y) -- (p1) coordinate[pos=-0.2](a\Y) coordinate[pos=1.2](a1) coordinate[pos=0.5](m1);
				\draw (a\Y) -- (a1);
			\else
				\path (p\Y) -- (p\X) coordinate[pos=-0.2](a\Y) coordinate[pos=1.2](a\X) coordinate[pos=0.5](m\X);
				\draw (a\Y) -- (a\X);
			\fi
		}
		\node[draw,red,circle] (S1) at (p4) {};
		\node[draw,red,circle] (S2) at (p5) {};
		\node[draw,red,circle] (S3) at (p1) {};
		\draw[-latex',red,thick] (S1) edge[bend right] (S2);
		\draw[-latex',red,thick] (S2) edge[bend right] (S3);
		\path[draw,red] (-1, .5) coordinate(c1) -- (0, 1.5) coordinate(c2) coordinate[pos=.5](cm);
		\draw[red] (c1) -- (c2) node[pos=1.2] {$c$};
		\draw[red,thick,->] (cm) -- ($(cm)!.8cm!90:(c2)$);
	\end{tikzpicture}
\end{figure}

We introduce \emph{slack variables} to fill gaps between constraints and corresponding right hand side.
$$
	s \coloneq b - Ax, \quad s \geq 0. 
$$
This yields to \emph{standard form} for LPs:
\begin{align*}
	\text{minimize }	& c^T x				& \text{minimize }		& c^T x\\
	\text{subject to }	& Ax + s = b		& \text{subject to }	& Ax = b\\
						& x, s \geq 0		&						& x \geq 0
\end{align*}
where the LP on the right is obtained by setting $x_{n+i} = s_i$ for $i \in \{1, \ldots, m\}$ and we extend $c$ and $A$ in the obvious way.

The transformation from canonical form to standard form preserves dimension and vertices of the polyhedron.
\begin{figure}[H]
	\tdplotsetmaincoords{70}{45}
	\centering
	\begin{tikzpicture}[scale=3, >=latex']
		\begin{scope}[tdplot_main_coords]
			\path[fill=gray!20] (0, 0, 0) -- (1, 0, 0) -- (0, 1.2, 0);
			\draw[->] (0, 0, 0) -- (1.2, 0, 0) node[pos=1.1] {$x_1$};
			\draw[->] (0, 0, 0) -- (0, 1.5, 0) node[pos=1.07] {$x_2$};
			\node at (0, 0, 0) {$\bullet$};
			\node at (1, 0, 0) {$\bullet$};
			\node at (0, 1.2, 0) {$\bullet$};
			\draw[-] (1, 0, 0) -- (0, 1.2, 0);
		\end{scope}
			\node at (.45, -.7) {$P = \{x \in \mathbb{R}^2_+ \mid x_1 + x_2 \leq 1\}$}; 
		\begin{scope}[tdplot_main_coords, shift={(2, 1.6)}]
			\path[fill=gray!20] (1, 0, 0) -- (0, 1.2, 0) -- (0, 0, .8);
			\draw[->] (0, 0, 0) -- (1.2, 0, 0) node[pos=1.1] {$x_1$};
			\draw[->] (0, 0, 0) -- (0, 1.5, 0) node[pos=1.07] {$x_2$};
			\draw[->] (0, 0, 0) -- (0, 0, 1) node[pos=1.1] {$s_1$};
			\node at (0, 0, .8) {$\bullet$};
			\node at (1, 0, 0) {$\bullet$};
			\node at (0, 1.2, 0) {$\bullet$};
			\draw[-] (1, 0, 0) -- (0, 1.2, 0) -- (0, 0, .8) -- (1, 0, 0);
		\end{scope}
			\node at (3, -.7) {$P' = \{(x, y) \in \mathbb{R}^3_+ \mid x_1 + x_2 + s_1 = 1\}$}; 
	\end{tikzpicture}
\end{figure}

Note that the slack variable $s_i = 0$ iff the $i$-th constraint is active. % complementary slackness?
We can also interpret $x$ as slack variable, just note that $x_j = 0$ iff $x_j \geq 0$ active.

Let $A_1, A_2, \ldots, A_n, A_{n+1}, \ldots, A_{n+m}$ be the columns of $A$ (the latter $m$ columns are unit vectors for slack varaiables). For $J \subseteq (1, \ldots, n+m)$, let $A_J$ denote the matrix consisting of columns $A_j$ with $j \in J$, e.g. for
$$
	A = \left(
		\begin{matrix}
			3 & 7 & 0 & -1 & 1 & 0\\
			-1 & -1 & -2 & 2 & 0 & 1
		\end{matrix}
	\right),
	\quad
	J = (5, 2)
	\implies 
	A_J = \left(
		\begin{matrix}
			1 & 7\\
			0 & -1
		\end{matrix}
	\right).
$$

A \emph{basis} $B = (B_1, \ldots, B_m) \subseteq (1, \ldots, n+m)$ is a subset of $m$ column indices such that the corresponding columns are linearly independent. $N = (1, \ldots, n+m) \setminus B$ is called \emph{non basis}. Variables $x_j$ with $j \in B$ are called \emph{basic variables}, and \emph{non-basic variables} if $i \in N$.

A vector $x \in \mathbb{Q}^{n+m}$ is a \emph{basic solution} to $Ax = b$, $x \geq 0$ if there is a basis $B$ such that
\begin{itemize}
	\item $A_B x_B = b$ (\emph{uniqueness}),
	\item $x_N = 0$ (\emph{at boundary}, \emph{vertex}).
\end{itemize}
If additionally $x_B \geq 0$ holds $x$ is called \emph{feasible basic solution}.

\begin{theorem}
	Every feasible basic solution corresponds to exactly one vertex of $P$.
\end{theorem}
Basic solution are also called \emph{extreme point solutions}.

We need $\dim P$ constraints to describe a vertex. The non-basic variables correspond to the active constraints.
\begin{figure}[H]
	\centering
	\begin{tikzpicture}
		\path[fill=gray!20] (0, 0) coordinate(p1) -- (2, 1) coordinate(p2) -- (4, 1) coordinate(p3) -- (6, 0) coordinate(p4) -- (5, -1) coordinate(p5);
		\foreach \X [count=\Y] in {2,...,5} {
			\path (p\Y) -- (p\X) coordinate[pos=-0.2](a\Y) coordinate[pos=1.2](a\X); 
			\ifnum\Y=4
				\draw (a\Y) -- node[below right]{\scriptsize$\Y$} (a\X);
			\else 
				\draw (a\Y) -- node[above] {\scriptsize$\Y$} (a\X);
			\fi
		}	
		\node[draw,circle,red,label={[align=left,red,shift={(1.5, 0)}]\scriptsize{At this vertex, the slack}\\[-.5em]\scriptsize{variables of constraint 2}\\[-.5em]\scriptsize{and 3 are $0$.}}] at (p3) {};
	\end{tikzpicture}
\end{figure}

Note that the basis in one vertex is not necessarily unique. We call those vertices \emph{degnerate}.
\begin{figure}[H]
	\centering
	\begin{tikzpicture}[scale=2]
		\path[fill=gray!20] (-.8, 0) -- (0, 0) -- (-.64, .64);
		\draw[-] (-1, 0) -- (1, 0) node[pos=1.05]{\scriptsize$1$};
		\draw[-] (-.8, .8) -- (.8, -.8) node[pos=1.05]{\scriptsize$2$};
		\draw[-] (0, 1) -- (0, -1) node[pos=1.05]{\scriptsize$3$};
		\draw[-] (.5, .75) -- (-.5, -.75) node[pos=1.05]{\scriptsize$4$};
		\node[align=left] at (3.5, 0) {Possible bases:\\$B = (1, 2), (1, 3), (1, 4), (2, 3), \ldots$};
	\end{tikzpicture}
\end{figure}

Given a standard form LP with $Ax = b$, $x \geq 0$ and basis $B$:
\begin{align*}
	& A_B x_B + A_N x_N &&= b\\
	\iff & x_B &&= \underbrace{A_B^{-1} b}_{\eqqcolon \bar{b}} - \underbrace{A_B^{-1} A_N}_{\eqqcolon \bar{A}_N} \underbrace{x_N}_{= 0}. 
\end{align*}
Using the objective function $z(x) = c^T x$:
\begin{align*}
	z(x) &= c^T x\\
	&= c_B^T x_B + c_N^T x_N\\
	&= c_B^T(A_B^{-1} b - A_B^{-1} A_N x_N) + c_N^T x_N\\
	&= c_B^T A_B^{-1} - c_B^T A_B^{-1} A_N x_N + c_N^T x_N\\
	&= \underbrace{c_B^T A_B^{-1} b}_{\eqqcolon \bar{z}} + (\underbrace{c_N^T - c_B^T A_B^{-1} A_N}_{\eqqcolon \bar{c}_N^T~\emph{''reduced cost``}}) \underbrace{x_N}_{= 0}.
\end{align*}
Optimality condition: Basis $B$ (and the corresponding vertex) optimal if reduced cost $\bar{c}_N^T \leq 0$. Intuitively, no non-basic variable can be increased without decreasing the value of $z$.

Otherwise we can find a non-basic variable that can ''improve`` the objective value. This means we deactivate a constraint (increasing its slack) and move to another vertex:
\begin{itemize}
	\item Initially: Vertex given by $B, N$.
	\item If there is a non-basic variable $x_s$, $s \in N$, with $\bar{c}_s > 0$, it is beneficial to increase $x_s$ (currently $x_s = 0$).
	\item Since $x_B = A_B^{-1} b - A_B^{-1} A_N x_N$, the values of basic-variables decrease if $A_B^{-1} A_s > 0$.
	\item The maximum value for $x_s$ is determined by ''the first`` basic variable which becomes $0$.
	\item If this never happens, i.e. $A_B^{-1} A_s \leq 0$, then $x_s$ can be arbitrarily  increased; in this case the objective value is unbounded.
\end{itemize}

The first basis: If $b \geq 0$, all slack variables are a feasible basis, i.e. $B = (n+1, \ldots, n+m)$, and hence, $A_B = A_B^{-1} = \mathbbm{1}_m$ and $\bar{A}_N = A_N$, $\bar{b} = b$. The first basic solution is then $x_{n+i} = b_i$ for $i \in \{1, \ldots, m\}$ and $x_1 = \ldots = x_n = 0$ (i.e. the origin). Since $c_B^T = 0$ (all slack), we have $\bar{c}_N^T = C_N^T$ and $\bar{z} = 0$. For calculation by hand, we can store all coefficients in a \emph{dictionary} (or \emph{tableau}):
\begin{table}[H]
	\def\arraystretch{1.3}
	\centering
	\begin{tabular}{c|cc|c|}
		\toprule
		\ & $\bar{c}_N^T$ & $0$ & $\bar{z}$\\
		\midrule
		$x_B$ & $\bar{A}_N$ & $\mathbbm{1}_m$ & $\bar{b}$\\
		\bottomrule
		\ & $x_N$ & $x_B$ & \
	\end{tabular}
\end{table}

The basic Simplex algorithm works in two stages:
\begin{enumerate}[label=\arabic*.]
	\item Find a feasible basic solution, i.e. a vertex.
	\item Improvement steps, i.e. jump to best adjacent vertex.
\end{enumerate}
We first only consider the second stage, which is sufficient if setting $x_1 = \ldots = x_n$ (every non-slack variable) to $0$ is a feasible solution. We add stage 1 later in this document.

\begin{algorithm}[H]
	\caption{Basic Simplex algorithm -- stage 2}
	\label{alg:simplex}
	\tcc{We are given a feasible basic solution}
	\While{not $\bar{c}_N^T \leq 0$}{
		\tcp{Pricing: choose best pivot column (Dantzig rule)}
		$s \coloneq \arg\max_{j \in N} \{\bar{c}_j > 0\}$.\\
		\If{$\bar{A}_s \leq 0$}{
			\Return{unbounded}
		}
		\tcp{Ratio test: choose best pivot row}
		$r \coloneq \arg\min_{i \in B} \left\{\frac{\bar{b}_i}{\bar{a}_{is}} \mid \bar{a}_{is} > 0\right\}$.\\
		\tcp{Pivoting}
		$B \coloneqq B \setminus \{r\} \cup \{s\}$.\\
		$N \coloneqq N \setminus \{s\} \cup \{r\}$.\\
		$a_{rj} \coloneqq \frac{a_{rj}}{a_{rs}}$ for $j \in \{1, \ldots, n+m\}$.\\
		$a_{rs} \coloneqq 1$ and $a_{is} = 0$ for $i \in \{0, \ldots, n\} \setminus \{r\}$.~~~~~~~~~\tcp{$0$ refers to $\bar{c}$ and $\bar{z}$ row}
		$a_{ij} \coloneqq a_{ij} - \frac{a_{rj} a_{is}}{a_{rs}}$ for $i \in \{0, \ldots, n\} \setminus \{r\}, j \in \{1, \ldots, n+m\} \setminus \{s\}$.
	}
	\Return{optimal solution}
\end{algorithm}

In the following we demonstrate the Simplex method on a small example that captures the whole pivoting routines.
\begin{example*}
	We consider the LP in canonical form
	\begin{align*}
		\text{maximize }	& 2 x_1 + x_2\\
		\text{subject to }	& 2x_1 - 3x_2 \leq 6\\
							& x_1 + x_2 \leq 4\\
							& x_1, x_2 \geq 0.
	\end{align*}
	The corresponding polytope is sketched in the next figure.
	\begin{figure}[H]
		\centering
		\begin{tikzpicture}
			\draw[->] (0, 0) -- (5, 0) node[below] {$x_2 \geq 0$};
			\draw[->] (0, 0) -- (0, 5) node[left] {$x_1 \geq 0$};
			\draw[-] (2.25, -.5) -- (4, 2/3) node[pos=1.1,right]{$2x_1-3x_2 \leq 6$};
			\draw[-] (-.5, 4.5) -- (4, 0) node[pos=.5, above right]{$x_1+x_2 \leq 4$};
			\draw[->, red] (3, 3.5) coordinate(a) -- (4, 4) coordinate(b) node[right] {$c^T$};
			\draw[-, red] ($(a)!.5cm!90:(b)$) -- ($(a)!.5cm!-90:(b)$);
		\end{tikzpicture}
	\end{figure}
	The corresponding LP in standard form is
	\begin{align*}
		\text{maximize }	& 2x_1 + x_2\\
		\text{subject to }	& 2x_1 - 3x_2 + x_3 = 6\\
							& x_1 + x_2 + x_4 = 4\\
							& x_1, x_2, x_3, x_4 \geq 0.
	\end{align*}

	Since  $b = (6, 4) \geq (0, 0)$, we can choose the slack variables as basis, i.e. $B = (3, 4)$. Thus, the first basic solution is $(x_1, x_2, x_3, x_4) = (0, 0, 6, 4)$. From the standard form, we construct the initial simplex tableau.

	\begin{minipage}{.49\textwidth}
		\begin{table}[H]
			\centering
			\begin{tabular}{c|cccc|c|}
				\toprule
				\ & $2$ & $1$ & $0$ & $0$ & $0$\\
				\midrule
				$x_3$ & \circled{$2$} & $-3$ & $1$ & $0$ & $6$\\
				$x_4$ & $1$ & $1$ & $0$ & $1$ & $4$\\
				\bottomrule
				\ & $x_1$ & $x_2$ & $x_3$ & $x_4$ & \
			\end{tabular}
		\end{table}
	\end{minipage}
	\begin{minipage}{.49\textwidth}
		\begin{figure}[H]
			\centering
			\begin{tikzpicture}[scale=.6]
				\draw[->] (0, 0) -- (5, 0);
				\draw[->] (0, 0) -- (0, 5);
				\draw[-] (2.25, -.5) -- (4, 2/3);
				\draw[-] (-.5, 4.5) -- (4, 0);
				\node[draw,circle,red,inner sep=2pt] at (0, 0) {};
				\draw[->, red] (3, 3.5) coordinate(a) -- (4, 4) coordinate(b);
				\draw[-, red] ($(a)!.5cm!90:(b)$) -- ($(a)!.5cm!-90:(b)$);
			\end{tikzpicture}
		\end{figure}
	\end{minipage}


	As we can see the greatest improvement of $\bar{z}$ can be obtained by increasing $x_1$ to a positive value ($\bar{c}_1 = 2 > 1 = \bar{c}_2$). Since $x_B = \bar{b} - \bar{A}_1 x_1$, we have to decreas basic variables that have a positive value in $\bar{A}_1 = (2, 1)^T$ (i.e. all of them): Increasing $x_1$ by $1$ forces $x_3$ to decrease by $2$ and $x_4$ by $1$. We can only decrease $x_3, x_4$ until one of them falls to $0$, i.e. $x_1$ can only be increased to $\min \{\frac{6}{2}, \frac{4}{1}\} = 3$. Hence, in this case $x_3$ drops to $0$. Since $x_1$ becomes a basic variable, its column should become $(1, 0)^T$, so we do similar transformation as in the Gaussian eliminination with the circled $2$ as pivot. Similarly, the reduced cost should become $0$.

	\begin{minipage}{.49\textwidth}
		\begin{table}[H]
			\centering
			\begin{tabular}{c|cccc|c|}
				\toprule
				\ & $0$ & $4$ & $-1$ & $0$ & $-6$\\
				\midrule
				$x_1$ & $1$ & $-\frac{3}{2}$ & $\frac{1}{2}$ & $0$ & $3$\\
				$x_4$ & $0$ & \circled{$\frac{5}{2}$} & $-\frac{1}{2}$ & $1$ & $1$\\
				\bottomrule
				\ & $x_1$ & $x_2$ & $x_3$ & $x_4$ & \
			\end{tabular}
		\end{table}
	\end{minipage}
	\begin{minipage}{.49\textwidth}
		\begin{figure}[H]
			\centering
			\begin{tikzpicture}[scale=.6]
				\draw[->] (0, 0) -- (5, 0);
				\draw[->] (0, 0) -- (0, 5);
				\draw[-] (2.25, -.5) -- (4, 2/3);
				\draw[-] (-.5, 4.5) -- (4, 0);
				\node[draw,circle,red,inner sep=2pt] at (3, 0) {};
				\draw[->, red] (3, 3.5) coordinate(a) -- (4, 4) coordinate(b);
				\draw[-, red] ($(a)!.5cm!90:(b)$) -- ($(a)!.5cm!-90:(b)$);
			\end{tikzpicture}
		\end{figure}
	\end{minipage}

	Note that by doing these Gaussian transformations we obtain $-6$ for $\bar{z}$, i.e. the wrong sign but we can live with this technical defect.
	The current solution now is $(3, 0, 0, 1)$ which can be improved by increasing $x_2$ since $\bar{c}_2 = 4 > 0$. Note that the second constraint is not binding yet, as its slack ist positive. However, the first constraint is binding (we designed it that way by decreasing its slack to $0$). Now we use $\frac{5}{2}$ as pivot as it is the only positive entry in the $x_2$-column.
	
	\begin{minipage}{.49\textwidth}
		\begin{table}[H]
			\centering
			\begin{tabular}{c|cccc|c|}
				\toprule
				\ & $0$ & $0$ & $-\frac{1}{5}$ & $-\frac{8}{5}$ & $-\frac{37}{5}$\\
				\midrule
				$x_1$ & $1$ & $0$ & $\frac{1}{5}$ & $\frac{3}{5}$ & $\frac{18}{5}$\\
				$x_2$ & $0$ & $1$ & $-\frac{1}{5}$ & $\frac{2}{5}$ & $\frac{2}{5}$\\
				\bottomrule
				\ & $x_1$ & $x_2$ & $x_3$ & $x_4$ & \
			\end{tabular}
		\end{table}
	\end{minipage}
	\begin{minipage}{.49\textwidth}
		\begin{figure}[H]
			\centering
			\begin{tikzpicture}[scale=.6]
				\draw[->] (0, 0) -- (5, 0);
				\draw[->] (0, 0) -- (0, 5);
				\draw[-] (2.25, -.5) -- (4, 2/3);
				\draw[-] (-.5, 4.5) -- (4, 0);
				\node[draw,circle,red,inner sep=2pt] at (3.6, .4) {};
				\draw[->, red] (3, 3.5) coordinate(a) -- (4, 4) coordinate(b);
				\draw[-, red] ($(a)!.5cm!90:(b)$) -- ($(a)!.5cm!-90:(b)$);
			\end{tikzpicture}
		\end{figure}
	\end{minipage}

	Note since $a_{12} = -\frac{3}{2} < 0$ in the previous tableau, by increasing $x_2$, we actually were able to increase $x_1$ further to $\frac{18}{5} = 3.6$ (observe the first constraint). 
	The reduced cost of any variable are now non-positive; hence, there is no suitable variable to increase and the current solution $(\frac{18}{5}, \frac{2}{5}, 0, 0)$ with objective value $\frac{37}{5} = 7.4$ is optimal.
\end{example*}

Now we have a look at the first stage, in the case when there is some $b_i < 0$, i.e. a constraint 
$$
	\sum_{j=1}^n a_{ij} x_j \leq b_i
$$
that makes the origin infeasible.

\begin{figure}[H]
	\centering
	\begin{tikzpicture}
				\draw[->] (0, 0) -- (3, 0);
				\draw[->] (0, 0) -- (0, 3);
				\draw[-] (-.5, 1) -- (2, 3);
				\draw[-,red] (-.5, 2.5) -- (2, -.5);
				\draw[-] (2.5, -.5) -- (3, 2.5);
				\draw[-] (1, 3) -- (3.5, 1);
				\node[red,draw,fill,circle,inner sep=2pt] at (0, 0) {};
	\end{tikzpicture}
\end{figure}

The question that now arises is, how to obtain an initial basic solution---if there exists any---or how to determine whether $P = \emptyset$. 

To this end we introduce \emph{artificial variables} (not to be confused with slack variables) for every constraint that has a negative right-hand side. All artificial variables have very large penalty cost $M$, i.e. their objective coefficient is $-M$.
The constraint from above written in standard form would then be
$$
	\sum_{j=1}^n a_{ij} x_j + s_i - y_i \leq b_i
$$
where $s_i$ denotes the slack variable of that constraint and $y_i$ the artificial variable. The initial basis now consists of all artificial variables and all slack variables to which no artificial variable exists. After that we can start the usual Simplex algorithm. As soon as the artificial variables become non-basic, we can disregard them. If we do not succeed then $P = \emptyset$ or $M$ was not big enough. Alternatively, one can minimize the sum of artificial variables as objective function. If then the optimal objective value is positive, then $P = \emptyset$.

\begin{algorithm}[H]
	\caption{Basic Simplex algorithm -- stage 1}
	\For{$i \in \{1, \ldots, m\}$ with $b_i < 0$}{
		$b_i \coloneqq -b_i$ and $a_{ij} \coloneqq -a_{ij}$ for $j \in \{1, \ldots, n\}$.\\
		$a_{-1j} \coloneqq a_{-1j} + M a_{ij}$.~~~~~~~~~~~~~~~~~~~~~~~~\tcp{row $-1$ refers to $M$-row}
	}
	Apply stage 2 steps to row $-1$ until no artificial variable in basis.\\
	Delete artificial variables and row $-1$.
\end{algorithm}

\begin{example*}
	Consider the following LP in canonical form:
	\begin{align*}
		\text{maximize }	& x_2\\
		\text{subject to }	& -x_1 - x_2 \leq -1\\
							& 2x_1 + 3x_2 \leq 6\\
							& x_1, x_2 \geq 0.
	\end{align*}
	Since the right hand side of the first constrtaint is negative, we introduce an artificial variable additionally to the slack variables to the corresponding LP in standard form:
	\begin{align*}
		\text{maximize }	& x_2 - Mx_5\\
		\text{subject to }	& -x_1 - x_2 + x_3 - x_5 = -1\\
							& 2x_1 + 3x_2 + x_4 = 6\\
							& x_1, x_2, x_3, x_4, x_5 \geq 0.
	\end{align*}
	We now start with an auxiliary tableau where we use $B = (5, 4)$ as basis.
	\begin{table}[H]
		\centering
		\begin{tabular}{c|ccccc|c|}
			\toprule
			\ & $0$ & $0$ & $0$ & $0$ & $-M$ & $0$\\
			\ & $0$ & $1$ & $0$ & $0$ & $0$ & $0$\\ 
			\midrule
			$x_5$ & $-1$ & $-1$ & $1$ & $0$ & $-1$ & $-1$\\
			$x_4$ & $2$ & $3$ & $0$ & $1$ & $0$ & $6$\\
			\bottomrule
			\ & $x_1$ & $x_2$ & $x_3$ & $x_4$ & $x_5$ & \
		\end{tabular}
	\end{table}
	First, we get rid of the negative right hand side and enforce large reduced cost w.r.t. the $M$-value for non-basic variables such that they become basic variables and we obtain a feasible basic solution for the original problem.
	\begin{table}[H]
		\centering
		\begin{tabular}{c|ccccc|c|}
			\toprule
			\ & $M$ & $M$ & $-M$ & $0$ & $0$ & $M$\\
			\ & $0$ & $1$ & $0$ & $0$ & $0$ & $0$\\ 
			\midrule
			$x_5$ & \circled{$1$} & $1$ & $-1$ & $0$ & $1$ & $1$\\
			$x_4$ & $2$ & $3$ & $0$ & $1$ & $0$ & $6$\\
			\bottomrule
			\ & $x_1$ & $x_2$ & $x_3$ & $x_4$ & $x_5$ & \
		\end{tabular}
	\end{table}
	We can use the $x_2$-column as pivot column ($x_1$ would also be fine), then we use the usual Gaussian steps to obtain a unit column (including the reduced cost rows) The ratio test suggests that we use the first row as pivot row and we obtain
	\begin{table}[H]
		\centering
		\begin{tabular}{c|ccccc|c|}
			\toprule
			\ & \red{$0$} & \red{$0$} & \red{$0$} & \red{$0$} & \red{$-M$} & \red{$0$}\\
			\ & $-1$ & $0$ & $1$ & $0$ & \red{$-1$} & $-1$\\ 
			\midrule
			$x_2$ & $1$ & $1$ & $-1$ & $0$ & \red{$1$} & $1$\\
			$x_4$ & $-1$ & $0$ & $3$ & $1$ & \red{$-3$} & $3$\\
			\bottomrule
			\ & $x_1$ & $x_2$ & $x_3$ & $x_4$ & \red{$x_5$} & \
		\end{tabular}
	\end{table}
	Now we do not have any positive reduced cost w.r.t. $M$ and noch artificial variables in the basis. By deleting the top row (reduced cost w.r.t. $M$) and the $x_5$-column (artificial variable), we can now continue with the usual Simplex algorithm.
\end{example*}

Next, we look at another example for the case when there is no feasible solution.
\begin{example*}
	Consider the following LP in standard form with slack variables $x_3$ and $x_4$, and artificial variable $x_5$:
	\begin{align*}
		\text{maximize }	& -3x_1 + 4x_2 - Mx_5\\
		\text{subject to }	& x_1 + x_2 + x_3 = 4\\
							& -2x_1 -3x_2 + x_4 - x_5 = -18\\
							& x_1, x_2, x_3, x_4, x_5 \geq 0.
	\end{align*}
	We obtain an auxiliary tableau with basis $B = (3, 5)$:
	\begin{table}[H]
		\centering
		\begin{tabular}{c|ccccc|c|}
			\toprule
			\ & $0$ & $0$ & $0$ & $0$ & $-M$ & $0$\\
			\ & $-3$ & $4$ & $0$ & $0$ & $0$ & $0$\\ 
			\midrule
			$x_3$ & $1$ & $1$ & $1$ & $0$ & $0$ & $4$\\
			$x_5$ & $-2$ & $-3$ & $0$ & $1$ & $-1$ & $-18$\\
			\bottomrule
			\ & $x_1$ & $x_2$ & $x_3$ & $x_4$ & $x_5$ & \
		\end{tabular}
	\end{table}
	Using the same initial step as in the previous example yields to
	\begin{table}[H]
		\centering
		\begin{tabular}{c|ccccc|c|}
			\toprule
			\ & $2M$ & $3M$ & $0$ & $-M$ & $0$ & $0$\\
			\ & $-3$ & $4$ & $0$ & $0$ & $0$ & $0$\\ 
			\midrule
			$x_3$ & $1$ & \circled{$1$} & $1$ & $0$ & $0$ & $4$\\
			$x_5$ & $2$ & $3$ & $0$ & $-1$ & $1$ & $18$\\
			\bottomrule
			\ & $x_1$ & $x_2$ & $x_3$ & $x_4$ & $x_5$ & \
		\end{tabular}
	\end{table}
	After pivoting we obtain
	\begin{table}[H]
		\centering
		\begin{tabular}{c|ccccc|c|}
			\toprule
			\ & $-M$ & $0$ & $-3M$ & $-M$ & $0$ & $6M$\\
			\ & $-7$ & $0$ & $-4$ & $0$ & $0$ & $-16$\\ 
			\midrule
			$x_2$ & $1$ & $1$ & $1$ & $0$ & $0$ & $4$\\
			$x_5$ & $-1$ & $0$ & $-3$ & $-1$ & $1$ & $6$\\
			\bottomrule
			\ & $x_1$ & $x_2$ & $x_3$ & $x_4$ & $x_5$ & \
		\end{tabular}
	\end{table}
	Now observe that there are no positive reduced cost w.r.t. $M$ but the artificial variable $x_5$ is still in the optimal basis. Hence, the original problem is infeasible. If there would be a feasible solution then there exists basic solution with basic variables drawn from $\{x_1, x_2, x_3, x_4\}$ with objective value $0$ w.r.t. $M$, i.e. basic solutions with artificial variables are never optimal.
\end{example*}

Now we make a sharp break and move on to a very enlightning concept of mathematical optimization: \emph{duality}. The motivation is to find an estimate on how large the optimum of an LP (that is to be maximized) can be, i.e. find a (strong) \emph{upper bound}. Note that for \emph{lower bounds}, we can evaluate any feasible solution. We use the constraints to find such upper bounds. Every \emph{cone combination} (i.e. a linear combination with only non-negative coefficients) of constraints yields to an upper bound if the sum of these coefficients (also called \emph{Lagrange multipliers}) are at least as large as the objective coefficients for each variable.
\begin{example*}
	Consider the following LP.
	\begin{align*}
		\text{maximize }	& 2x_1 + 4x_2 - 3x_3\\
		\text{subject to }	& x_1 + 3x_2 - x_3 \leq 4\\
							& x_1 + 2x_2 - 2x_3 \leq 3\\
							& x_1, x_2, x_3 \geq 0.
	\end{align*}
	From the first constraint, we can derive an upper bound on the objective function:
	$$
		z(x) = 2x_1 + 4x_2 - 3x_3 \leq 2(x_1 + 3x_2 - x_3) \leq 2 \cdot 4 = 8.
	$$
	If we use both constraints, we can obtain an even tighter bound:
	$$
		z(x) = 2x_1 + 4x_2 - 3x_3 \leq (x_1 + 3x_2 - x_3) + (x_1 + 2x_2 - 2x_3) \leq 4 + 3 = 7.
	$$
	If we want to find the best upper bound, consider the following:
	\begin{align*}
		z(x) = 2x_1 + 4x_2 - 3x_3 &\leq \lambda_1(x_1 + 3x_2 - x_3) + \lambda_2(x_1 + 2x_2 - 2x_3)\\
		&\leq (\lambda_1 + \lambda_2)x_1 + (3\lambda_1 + 2\lambda_2)x_2 + (-\lambda_1 - 2\lambda_2)x_3\\
		&\leq 4\lambda_1 + 3\lambda_2.
	\end{align*}
	This chain of inequalities hold if $\lambda_1 + \lambda_2 \geq 2 (= c_1)$, $3\lambda_1 + 2\lambda_2 \geq 4 (= c_2)$, $-\lambda_1 - 2\lambda_2 \geq -3 (= c_3)$, and of course $\lambda_1, \lambda_2 \geq 0$. We obtain the best (i.e. smallest) upper bound by minimizing $4\lambda_1 + 3\lambda_2$ subject to these four constraints. 
\end{example*}

Note that the minimization problem from the example is again an LP, which we call the \emph{dual LP} of the LP we started with (\emph{primal LP}). More formally we have
\begin{description}
	\item[primal LP] $\max \{c^Tx \mid \underbrace{Ax \leq b, x \geq 0}_{\eqqcolon P}\}$
	\item[dual LP] $\min \{\lambda^Tb \mid \underbrace{\lambda^TA \geq c^T, \lambda \geq 0}_{\eqqcolon D}\}$
\end{description}
By construction of the dual LP, we have the following property.
\begin{theorem}[weak duality]
	Let $P, D$ denote the polyhedra of a primal and a corresponding dual LP.
	\begin{enumerate}
		\item If $x \in P$ and $\lambda \in D$, then $c^Tx \leq \lambda^Tb$.
		\item If $P \neq \emptyset$, $c^Tx$ unbounded from above iff $D = \emptyset$.
		\item If $D \neq \emptyset$, $\lambda^Tb$ unbounded from below iff $P = \emptyset$.
	\end{enumerate}
	\begin{proof}
		\begin{enumerate}[label=\itshape{(\roman*)}]
			\item $c^Tx \leq \lambda^TAx \leq \lambda^Tb$.\qedhere
		\end{enumerate}
	\end{proof}
\end{theorem}

For each primal constraint, there is a dual variable; for each primal variable, there is a dual constraint. We do not need that the primal LP is in canonical form. By the following rules, we can dualize every LP.
\begin{table}[H]
	\centering
	\begin{tabular}{l|r}
		\toprule
		primal & dual\\
		\midrule
		maximize & minimize\\
		objective coeffiecients & right hand side\\
		right hand side & objective coefficients\\
		$A$ & $A^T$\\
		\midrule
		$a_i^T x \leq b$ & $\lambda_i \geq 0$\\
		$a_i^T x = b$ & $\lambda_i$ free\\
		$a_i^T x \geq b$ & $\lambda_i \leq 0$\\
		\midrule
		$x_j \geq 0$ & $\lambda^TA_j \geq c_j$\\
		$x_j$ free & $\lambda^TA_j = c_j$\\
		$x_j \leq 0$ & $\lambda^TA_j \leq c_j$\\
		\bottomrule
	\end{tabular}
\end{table}

In fact, we can also read the table above from right to left to dualize minimization problems. This yields to the following theorem.
\begin{theorem}
	The dual of a dual is the primal.
\end{theorem}

What makes duality interesting is that every dual solution is a certificate for optimality (or rather maximal gap to optimality). Especially if we have $x^\ast \in P, \lambda^\ast \in D$ with $c^Tx^\ast = \lambda^{\ast T}b$, then $x^\ast$ is optimal for the primal LP and $\lambda^\ast$ is optimal for the dual LP. Note that the concept of dual problems is not restricted to linear optimization; it can be applied to arbitrary non-linear problems, too. However, the following theorem is special and not true in arbitrary non-linear settings but always holds for linear programs.
\begin{theorem}[strong duality]
	If the primal LP has a finite optimal solution $x^\ast$, then the dual LP has a finite optimal solution $\lambda^\ast$. Moreover, 
	$$
		c^Tx^\ast = \lambda^{\ast T}b.
	$$
	\begin{proof}
		Let $B$ be an optimal basis for the primal LP, i.e. $x_B$ solves $A_B x_B = b \iff x_B = A_B^{-1}b$. Since $B$ is optimal, we have that the reduced cost are non-positive: 
		$$
			\bar{c}_N^T = c_N^T - \underbrace{c_B^T A_B^{-1}}_{\eqqcolon \lambda^T}A_N \leq 0
		$$
		We claim that $\lambda^T$ is optimal dual solution. For feasibility just note that $\lambda^T A \geq c^T$ because of the reduced cost. Moreover,
		$$
			c_B^T x_B = c_B^T A_B^{-1}b = \lambda^T b,
		$$
		i.e. the objective values match.
	\end{proof}
\end{theorem}

From duality we derive
\begin{itemize}
	\item primal optimality implies dual feasibility,
	\item primal feasibility implies dual optimaliyt.
\end{itemize}

Note that dual variables $\lambda^T = c_B^T A_B^{-1}$ are implicitly computed in the Simplex algorithm: Reduced cost $\bar{c}_N^T = c_N^T - \lambda^TA_N$. For slack variables $x_{n+i}$ is $c_{n+i} = 0$ and $A_{n+i}$ is the $i$-th unit vector.

There is also a very common economic interpretation of dual variables; ofthen they are called \emph{shadow prices} or \emph{opportunity costs}. A constraint often models the availability of some resource $i$. That is, given a primal LP
\begin{align*}
	\text{maximize }	& c^T x\\
	\text{subject to }	& Ax \leq b + \epsilon\\
						& x \geq 0,
\end{align*}
where we consider a right hand side that is \emph{relaxed} by some $\epsilon \geq 0$, the interpretation of a dual variable $\lambda_i$ for the $i$-th constraint is the possible increment of the objective value if one more unit of the $i$-th resource is available.
$$
	\lambda^T(b+\epsilon) = \lambda^Tb + \lambda^T\epsilon.
$$

\begin{theorem}[complementary slackness]
	A primal solution $x$ and a dual solution $\lambda$ are optimal iff
	\begin{enumerate}[label=\itshape(\roman*)]
		\item $a_i^T x = b_i$ or $\lambda_i = 0$ for all $i \in \{1, \ldots, m\}$. \label{thm:cs:1}
		\item $\lambda^TA_j = c_j$ or $x_j = 0$ for all $j \in \{1, \ldots, n\}$. \label{thm:cs:2}
	\end{enumerate}
	\begin{proof}
		By strong duality: $c^T x = \lambda^TAx = \lambda^T b$. Then we have by the first equation:
		$$
			(\underbrace{c^T - \lambda^TA}_{\geq 0}) \underbrace{x}_{\geq 0} = 0
		$$
		providing the proof for \ref{thm:cs:2} and for \ref{thm:cs:1}, we use the second equation for the analogous argument
		\[%\qedhere
			\underbrace{\lambda^T}_{\geq 0} (\underbrace{Ax - b}_{\geq 0}) = 0.\qedhere
		\]
	\end{proof}
\end{theorem}


We now want to analyze soundness and runtime of the Simplex algorithm. In the worst case the algorithm still needs an exponential number (in $m$) of iterations. Note that there are also algorithm that guarantee a runtime in polynomial time for solving LPs but it turns out that the Simplex algorithm is better in practice where it usually visits $\mathcal{O}(m)$ vertices.
\end{document}
